#pragma once

#include <map>
#include <vector>

#define SAFE_CLEAN(p) if(p) delete p;p = NULL;
#define SAFE_RETURN(p, ret) { SAFE_CLEAN(p);return ret; }

/* bencodeǰ׺stringķָ */
#define BC_PREFIX_INT			'i'
#define BC_PREFIX_LIST			'l'
#define BC_PREFIX_DICT			'd'
#define BC_SUFFIX				'e'
#define BC_STRING_DELIMITER		':'

/* BitCometǶļǰ׺Щļ */
#define BITCOMET_PADDING_FILE_PREFIX "_____padding_file"

/* ļĹؼ֣ļһbencodeֵֵͣĹؼ֣ر˵еֵַutf-8 */
#define KEYWORD_ANNOUNCE		"announce"		//bencodeַ
#define KEYWORD_ANNOUNCE_LIST	"announce-list"	//bencodeббǱҪؼ֣announce-listбǶбÿбһurlַ
#define KEYWORD_CREATION_DATE	"creation date"	//bencodeǱҪؼ֣ӵĴʱ,1970-1-1 00:00:00 UTC 
#define KEYWORD_COMMENT			"comment"		//bencodeַǱҪؼ֣ļıע
#define KEYWORD_COMMENT_UTF8	"comment.utf-8"	//bencodeַ,ؼҴӹٷ鲻BitCometչĹؼ֣ؼ־ͺǸΪһUTF-8
#define KEYWORD_CREATED_BY		"created by"	//bencodeַǱҪؼ֣ļ汾ʽ uTorrent/183BʾuTorrent 183B洴
#define KEYWORD_ENCODING		"encoding"		/*bencodeַǱҪؼ֣ٷļinfoֵpiecesεַʹõı뷽ʽ
												 *ʵʷָôı뷽ʽͬӰinfoֵڵַ֪ʲô */
#define KEYWORD_PUBLISHER		"publisher"		//bencodeַӵķߣؼҴӹٷҲ鲻
#define KEYWORD_PUBLISHER_UTF8	"publisher.utf-8"
#define KEYWORD_INFO			"info"			//bencodeֵ䣬ڵļ忴˵http://wiki.theory.org/BitTorrentSpecification

/* ЩؼinfoֵεĹؼ */
#define KEYWORD_INFO_PIECE_LENGTH	"piece length"	/* bencodeÿһĳȣλֽڣٷ524288512kֽڣвͬ*/

#define KEYWORD_INFO_PIECES			"pieces"		/* bencodeַÿĹϣֵSHA1̶20ֽڳϣַܺܳ
													 * ٷ˵byte string, i.e. not urlencodedȻĳȱ20ıҲͨ
													 * ĳȳ20һжٿ顣
													 * ע⣬ַǱ׼cַκλönullַַڸַ */

#define KEYWORD_INFO_PRIVATE		"private"		/* bencodeǱҪؼ֣ʵԿһBOOLΪ1ʱʾֻͨڵķõpeers
													 * Ϊ0δʱԴⲿpeersDHT */

/* ¹ؼǺļصģ忴˵http://wiki.theory.org/BitTorrentSpecification */
#define KEYWORD_NAME		"name"
#define KEYWORD_NAME_UTF8	"name.utf-8"//ͬKEYWORD_COMMENT_UTF8
#define KEYWORD_FILES		"files"
#define KEYWORD_PATH		"path"
#define KEYWORD_PATH_UTF8	"path.utf-8"//ͬKEYWORD_COMMENT_UTF8
#define KEYWORD_LENGTH		"length"

/* bencode */
enum BC_TYPE_NAME { BC_STRING, BC_INT, BC_LIST, BC_DICT };

struct _BC_Node;//Ľڵ

/* º */
struct CompareKey
{
	BOOL operator() (const char* psz1, const char* psz2)
	{
		return strcmp(psz1, psz2) < 0;//ϸֻpsz1Сpsz2ʱŷTRUE
	}
};

/* bencode */
typedef char*									BC_String;
typedef DWORDLONG								BC_Int;
typedef std::map<char*, _BC_Node, CompareKey>	BC_Dict;
typedef std::vector<_BC_Node>					BC_List;

/* ڵ㶨壬һڵĶ岻һο
 * BC_DictBC_Listʵһݹ鶨 */
typedef struct _BC_Node
{
	UINT Type;

	/* ʵʹunionʣmapvectorй/
	 * ޷ΪunionԱԷʽڵʱһҪж
	 * ڵֹͣڴдΥ */
	struct _Data 
	{
		BC_String	bcString;
		BC_Int		bcInt;
		BC_List		bcList;
		BC_Dict		bcDict;
	} Data;

} BC_Node, *LPBC_Node;






/* ڵļ */
typedef struct _Inner_File
{
	/* · */
	CString PathName;

	/* ļ */
	CString FileName;

	/* ļСλֽ */
	DWORDLONG FileSize;

	/* ļͣļֱṩԼBT FileResolverView.cppļжGetFileInfo */
	CString FileType;

	_Inner_File() { FileSize = 0; }
} InnerFile, *PInnerFile;

/* ṹҪõݣڵò
 * ʵ̻ŻֱҪݣûʵ֣
 * һԺпõԻǱȫ */
typedef struct _Values_Needed
{
	CString Seed_FileName;
	CString Seed_CreationDate;
	CString Seed_Comment;
	CString Seed_Creator;
	CString Seed_Publisher;
	int Seed_Encoding;//CodePage

	std::vector<InnerFile> Seed_Files;//ļб
} Values_Needed;

class CSeedResolver
{
private:
	UINT m_SeedFileSize;
	UINT m_Position;
	BC_Dict m_SeedDict;//ӵĸǸbencodeֵ
	std::vector<INT_PTR> vecAlloc;//ѷڴָ

	/* ȡļ */
	char* ReadSeedFile();

	/* ǷԽ(ļβ) */
	BOOL IsRangeValid(UINT nOffset = 0);

	/* ȡһbencodeַ(׼cַ) */
	char* GetBCString(char** pBuffer);

	/* ȡһbencode */
	DWORDLONG GetBCInt(char** pBuffer);

	/* ָĻǸݹ麯 */
	BC_Node ResovleBuffer(char** pBuffer);

	/* õһڵ㣬ֵΪýڵǷ */
	BOOL GetNode(const BC_Dict& Dict, char* pszKey, BC_Node& node);

	/* õڵļбֵΪǷɹ */
	BOOL GetMultiModeFileList(BC_List FileList, std::vector<InnerFile>& vec);

	/* һpathб */

	/* ͷŽзڴ */
	void DeallocAll();

	/* ׼cַ -> UnicodenCodePage = 0ʾʹڶĴҳ */
	void ConvertToUnicode( const char* pStr ,CString& s, int nCodePage = 0);

public:
	Values_Needed SeedInfo;

	CSeedResolver(const CString& SeedFileName);
	~CSeedResolver(void);

	/* ʼȵøúݷֵȷǷɹ */
	BOOL Resolve();


};
